/* author: Louis Hugues - created on 19 janv. 2005  */
package simbad.gui;
import javax.vecmath.Color3f;
import javax.vecmath.Vector3d;
import javax.vecmath.Vector3f;

import simbad.sim.*;
//import sun.tools.tree.ThisExpression;

/**
 * This demo shows a robot randomly picking red balls. It demonstrates the use of a picker actuator.
 */
public class Test2 extends EnvironmentDescription{
    

    /** The robot used in the demo.*/
    public class Robot extends Agent {
     //   PickerActuator picker;
        public Robot(Vector3d position, String name) {
            super(position, name);
            // add a picker actuator.
       //     picker = RobotFactory.addPicker(this);
        }

        /** Initialize Agent's Behavior */
        public void initBehavior() {
            setTranslationalVelocity(0.5);
        }

      
        /** Perform one step of Agent's Behavior */
        public void performBehavior() {
            if (collisionDetected())
                moveToStartPosition();
            if ((getCounter() % 80) == 0) {
                setRotationalVelocity(Math.PI / 2 * (0.5 - Math.random()));
                setTranslationalVelocity(0.5);
            }
            if (anOtherAgentIsVeryNear()){
                getVeryNearAgent().detach();
            }
            // if there is something to pick pick it. */
           /* if (picker.canPickItem()){
                picker.pickUp();
            }*/
        }
    }

    public Test2() {
        showAxis(false);
        setWorldSize(12);
        boxColor = new Color3f(0.6f,0.5f,.3f);
        // add the four walls 
       add(new Box(new Vector3d(-5,0,0),new Vector3f(0.1f,1,10),this));
		add(new Box(new Vector3d(0,0,-5),new Vector3f(10,1,0.1f),this));
		add(new Box(new Vector3d(5,0,0),new Vector3f(0.1f,1,10),this));
		add(new Box(new Vector3d(0,0,5),new Vector3f(10,1,0.1f),this));
		
		// add the robot
        add(new Robot(new Vector3d(0, 0, 0), "R1"));
        
        // add 30 apples randomly
        for( int n =0; n < 30;n++){
            double x =( Math.random()*8 - 4);
            double z = (Math.random()*8 - 4);
            if ((x <2 )|| (x > 2) || (z <2 )|| (z > 2)) 
               add(new CherryAgent(new Vector3d(x, 0, z), "apple", 0.15f));
        }
    }
    
    
    /** The simbad main.*/
    public static void main(String[] args) {
        System.setProperty("j3d.implicitAntialiasing", "true");
        Simbad frame = new Simbad(new Test2() ,false);
    }


}
