/*
 *  NS - Neuroevolutionary Solver
 *  Copyright (C) 2008 Robert Lucas
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 -----------------------------------------------------------------------------
 * $Author: Robert Lucas $ 
 * $Date: 2008/10/11 17:20:00 $
 * $Revision: 1.00 $
 */
package simbad.holodeck;

import simbad.sim.ChaosAgent;
import simbad.sim.Wall;
import javax.vecmath.Vector3d;

public class Evaluator_Empty extends Evaluator_Environment {
	
    public Evaluator_Empty() {
    	
		//perimeter Walls
        Wall north = new Wall(new Vector3d(8, 0, 0), 20, 1, this);
        north.rotate90(1);
        add(north);
        Wall south = new Wall(new Vector3d(-8, 0, 0), 20, 1, this);
        south.rotate90(1);
        add(south);
        Wall east = new Wall(new Vector3d(0, 0, 10), 16, 1, this);
        add(east);
        Wall west = new Wall(new Vector3d(0, 0, -10), 16, 1, this);
        add(west);
		
        ChaosAgent Agent = new ChaosAgent(new Vector3d(0, 0, 0), "Chaos");
		add(Agent);
    }
}
