/*
 *  NS - Neuroevolutionary Solver
 *  Copyright (C) 2008 Robert Lucas
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 -----------------------------------------------------------------------------
 * $Author: Robert Lucas $ 
 * $Date: 2008/10/11 17:20:00 $
 * $Revision: 1.00 $
 */
package simbad.picoevo.ext.evolution;

import simbad.picoevo.core.evolution.*;
import simbad.picoevo.core.representation.*;

public class InitialisationOperator_Element_NEAT_NGene extends
		InitialisationOperator_Element {
	
	protected int neuronType; //0=none, 1=input, 2=output, 3=hidden, 4=bias
	protected double activationResponse;
	protected int neuronID; //unique to Individual id for this neuron.
	double splitX;
	double splitY;
	protected int innovationID;
	protected boolean recurrent;
	protected boolean enabled;
	
	public InitialisationOperator_Element_NEAT_NGene() {
	}

	public InitialisationOperator_Element_NEAT_NGene(String __name) {
		super(__name);
	}
	
	public InitialisationOperator_Element_NEAT_NGene(int _neuronType, double _activationResponse, int _neuronID,
													double _splitX, double _splitY, int _innovationID, 
													boolean _recurrent, boolean _enabled) {
		neuronType = _neuronType;
		activationResponse = _activationResponse;
		neuronID = _neuronID;
		splitX = _splitX;
		splitY = _splitY;
		innovationID = _innovationID;
		recurrent = _recurrent;
		enabled = _enabled;
	}

	public InitialisationOperator_Element_NEAT_NGene(String __name, int _neuronType, double _activationResponse, 
													int _neuronID, double _splitX, double _splitY, int _innovationID, 
													boolean _recurrent, boolean _enabled) {
		super(__name);
		neuronType = _neuronType;
		activationResponse = _activationResponse;
		neuronID = _neuronID;
		splitX = _splitX;
		splitY = _splitY;
		innovationID = _innovationID;
		recurrent = _recurrent;
		enabled = _enabled;
	}

	@Override
	public void initialise(Element object) {
		//No need to perform operations here, handled by the constructors and later by variation operators.
	}

}
