/*
 *  NS - Neuroevolutionary Solver
 *  Copyright (C) 2008 Robert Lucas
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 -----------------------------------------------------------------------------
 * $Author: Robert Lucas $ 
 * $Date: 2008/10/11 17:20:00 $
 * $Revision: 1.00 $
 */
package simbad.picoevo.ext.evolution;

import simbad.picoevo.toolbox.*;

public class ParameterSet_Evolution_SDNEAT extends ParameterSet_Evolution_NEAT {
	
	protected double mutationRateSD; //rate of segmental duplications
	protected int maxSDMutationAttempt; //max attempts to find a suitable segment
	protected double subMutationRateSD; //rate that SD's genes are mutated after duplication
	
	public void displayInformation() {
		Display.info("\n##Parameter Setup##");
		Display.info("- Maximisation?             : " + this.getOptimisationFlag());
		Display.info("- Pop. Initialisation Op.   : " + this.getPopulationInitialisationOperator().getName());
		Display.info("- Ind. Initialisation Op.   : " + this.getIndividualInitialisationOperator().getName());
		Display.info("- max number of generations : " + this.getGenerations());
		Display.info("- initial population size   : " + this.getInitPopSize());
	}

	public double getMutationRateSD() {
		return mutationRateSD;
	}

	public void setMutationRateSD(double mutationRateSD) {
		this.mutationRateSD = mutationRateSD;
	}

	public int getMaxSDMutationAttempt() {
		return maxSDMutationAttempt;
	}

	public void setMaxSDMutationAttempt(int maxSDMutationAttempt) {
		this.maxSDMutationAttempt = maxSDMutationAttempt;
	}

	public double getSubMutationRateSD() {
		return subMutationRateSD;
	}

	public void setSubMutationRateSD(double subMutationRateSD) {
		this.subMutationRateSD = subMutationRateSD;
	}
}
