/*
 * Author: nicolas.bredeche(@)lri.fr
 * Created on 14 janv. 2006
 * 
 */

package simbad.picoevo.ext.evolution;

import simbad.picoevo.core.*;
import simbad.picoevo.core.evolution.*;
import simbad.picoevo.core.representation.*;
import simbad.picoevo.ext.*;
import simbad.picoevo.ext.representation.*;
import simbad.picoevo.toolbox.*;


public class SelectionOperator_MuLambda extends SelectionOperator {

	public SelectionOperator_MuLambda() { super("MuLambda selection operator"); }
	public SelectionOperator_MuLambda(String __name) { super(__name); }
	
	public void performSelection ( PopulationObject __population )
	{
		Population population = (Population)__population;
		
		// A population that contains permission to manipulate a list that contains clones of original individuals (one can theoretically do anything thus)
		// un population container permet de manipuler une liste qui contient des *clones* des individus originaux (on peut theoriquement faire n'importe quoi donc...)
		PopulationContainer newpop = new PopulationContainer (); // newpop va contenir ma liste d'individus pour la prochaine generation
																 // newpop will contain my list of individuals for the previous generation
		PopulationContainer newpopbuffer; // newpopbuffer va contenir des bouts de la pop finale
										  // newpopbuffer will contain some (lit. boils, could mean instances) of the final pop
		// TODO : revoir les methodes de PopulationContainer pour cloner systematiquement les individus pass en parametres. Sauf nom de methode explicite!!!
		// to do: review the methods of PopulationContainer to systematically clone individuals passing within parameters. Except the explicit name of the method!!!


		// un population viewer permet de manipuler une liste qui *pointe* sur les individus originaux (attention a pas faire n'importe quoi)
		// a population viewer allows manipulation of a list that points to original individuals (attention(note?) does not have to do anything)

		PopulationView populationView = SelectionOperator_SimpleRank.performSelectionView(population,((ParameterSet_Evolution_mulambdaES)population.getTemplate()).getMu()); // on passe par un view car parfois on a besoin de faire un traitement avant de reintegrer les individus
																																											 // we pass by a view because sometimes we need to do a treatment before reintegrating individuals
		// on peut aussi les ajouter a la main... : populationView.addIndividual(monIndividu);
		// we can also add them by hand... :populationView.addlnindividual(monindividu);

		int nb = ( ((ParameterSet_Evolution_mulambdaES)population.getTemplate()).getLambda() + ((ParameterSet_Evolution_mulambdaES)population.getTemplate()).getMu() ) / ((ParameterSet_Evolution_mulambdaES)population.getTemplate()).getMu();
		for ( int j = 0 ; j != nb ; j++ ) // emulate (muPLUSlambda)-ES ("PLUS" should be made clearer later) TODO
		{
			newpopbuffer = new PopulationContainer (populationView);
			if ( j != 0 || !((ParameterSet_Evolution_mulambdaES)population.getTemplate()).isMuPlusLambda() ) // premiere passe pour les mu individus que l'on conserve. Ensuite on gerera les lambdas.
																											 // first pass for the driven individuals that are being kept. Instead we will manage the lambdas
			{
				newpopbuffer.addOperatorList(__population.getVariationOperatorList());
				newpopbuffer.performVariations();
			}
			newpop.mergeWithContainer(newpopbuffer); // after this, newpopbuffer does not contain any individuals.
		}

		// replace old population with the new frankensteined one 
		population.renewPopulation(newpop); // after this, newpop does not contain any individuals and maxOnePop contains only new individuals.
		// TODO : en implmentant mergeWithContainer en tant que mergeWithPopulation dans Population,
		// to do: while implementing mergeWithContainer as mergeWithPopulation within Population,

	}
}
