/*
 *  NS - Neuroevolutionary Solver
 *  Copyright (C) 2008 Robert Lucas
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 -----------------------------------------------------------------------------
 * $Modified by: Robert Lucas $ 
 * $Date: 2008/10/11 17:20:00 $
 * $Revision: 1.00 $
 */


/*
 * Author: nicolas.bredeche(@)lri.fr
 * Created on 15 jan. 2006
 * 
 * 
 */

package simbad.picoevo.toolbox;

import simbad.piconode.toolbox.*;

public class Version {

	// candidate names :
	// serious: Evoorg, Evorgue, evoluciel, evoke, evoque, evolune, evorchidee, evorchis, evoledge, nuEvo, "Evo World!" 
	// not serious : PicoEvo(*), EvoCoinCoin, EvoYoupi, Evotchutchu(*), EvoTchouTchou, EvoTchooTchoo, Evolove :-), ...
	
	static String _versionInfo = "PicoEvo";
	static String _versionNum = "0.9beta2";
	static String _versionBuild = "200601301714";
	
	static String nsName = "Neuroevolutionary Solver";
	static String nsAlgorithm1 = "NEAT: Neuro Evolution of Augmenting Topologies";
	static String nsAlgorithm2 = "SDNEAT: Symmetric Duplication NEAT";
	static String nsVersionNum ="0.9 Beta Release 1";
	static String nsAuthor = "Robert Lucas";
	static String simbadName = "Simbad Robots Simulator";
	static String simbadVersion = "1.4";
	static String simbadAuthor = "Louis Hugues";
	
	
	static public void displayCurrentReleaseInformation()
	{
		Display.info("\n# " + _versionInfo + "\n# Author: nicolas.bredeche(at)lri.fr\n# Version " + _versionNum + "\n# build " + _versionBuild+"\n");
	}

	static public void displayNeuroevolutionarySolverReleaseInformation()
	{
		Display.info(nsName + "\n");
		Display.info("Author: " + nsAuthor);
		Display.info("Version: " + nsVersionNum);
		Display.info("Available evolution algorithms");
		Display.info("   " + nsAlgorithm1);
		Display.info("   " + nsAlgorithm2);
		Display.info("\n");
		Display.info("System composed of following sub systems:");
		Display.info("\n# " + simbadName + "\n# Author: " + simbadAuthor + "\n# Version " + simbadVersion + "\n");
		displayCurrentReleaseInformation();
		simbad.piconode.toolbox.Version.displayCurrentReleaseInformation();
		
	}
	
}
