package simbad.piconode.core.arc;

import simbad.piconode.XmlRepresentation;
import simbad.piconode.toolbox.*;
import simbad.piconode.core.node.*;
import simbad.piconode.core.operator.*;
import simbad.picoevo.ext.representation.*;

/*
 * Created on 30 dec. 2004
 * bredeche(at)lri(point)fr
 * 
 * Note: The Arc class is a general purpose class for modelling Arcs
 * between nodes. Arc are 1-to-1 link.
 *
 */
public class Arc implements XmlRepresentation, java.io.Serializable{

    /* ### Data ### */
    
    protected		Node _source;
    protected		Node _target;
    //added this to help reconstruction of a NEAT Individual after phenotype testing
    protected		Element_NEAT_LGene lGene;
    
    /*
     * Constructors
     */

    public Arc ()
    {
    }

    
    public Arc (Node __source, Node __target)
    {
        _source = __source;
        _target = __target;
        lGene = null;

        //_source.addOutgoingArc(this);
        //_target.addIncomingArc(this);
    }

    /*
     * Methods
     */
    
    public Node getSource()
    {
        return (_source);
    }

    public Node getTarget()
    {
        return (_target);
    }

    public Element_NEAT_LGene getLGene() {
		return lGene;
	}


	public void setLGene(Element_NEAT_LGene gene) {
		lGene = gene;
	}


	/**
     * Thomas Darde TER NNEditor
     * @return an Xml String representation of this objetc
     */
    public String toXml(){
    		String retour="<link";
    		retour+=" idFrom=\""+ _source.hashCode()+ "\"";
    		retour+=" idTo=\""+ _target.hashCode()+ "\">";
    		retour+="</link>";
    		return retour;
    }
    
    



}
