/*
 *  NS - Neuroevolutionary Solver
 *  Copyright (C) 2008 Robert Lucas
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 -----------------------------------------------------------------------------
 * $Author: Robert Lucas $ 
 * $Date: 2008/10/11 17:20:00 $
 * $Revision: 1.00 $
 */
package simbad.picoevo.ext.evolution;

import simbad.picoevo.core.evolution.*;
import simbad.picoevo.core.representation.*;
import simbad.picoevo.ext.representation.*;
import simbad.picoevo.toolbox.*;

public class InitialisationOperator_Element_NEAT_Gene extends
		InitialisationOperator_Element {

	private InitialisationOperator_Element_NEAT_NGene _initialisationOperator_Element_NEAT_NGene = null;
	private InitialisationOperator_Element_NEAT_LGene _initialisationOperator_Element_NEAT_LGene = null;
	
	public InitialisationOperator_Element_NEAT_Gene() {
		_initialisationOperator_Element_NEAT_NGene = new InitialisationOperator_Element_NEAT_NGene();
		_initialisationOperator_Element_NEAT_LGene = new InitialisationOperator_Element_NEAT_LGene();
	}

	public InitialisationOperator_Element_NEAT_Gene(String __name) {
		super(__name);
		_initialisationOperator_Element_NEAT_NGene = new InitialisationOperator_Element_NEAT_NGene();
		_initialisationOperator_Element_NEAT_LGene = new InitialisationOperator_Element_NEAT_LGene();
	}

	@Override
	public void initialise(Element object) {
		if(object instanceof Element_NEAT_NGene)
		{
			_initialisationOperator_Element_NEAT_NGene.initialise(object);
		}
		else if(object instanceof Element_NEAT_LGene)
		{
			_initialisationOperator_Element_NEAT_LGene.initialise(object);
		}
		else
		{
			Display.error(""+this.getClass().getName()+"::initialise(.) - Class cast exception");
		}
	}

}
